/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
package com.sos.scheduler.db;

/**
* \class SchedulerInstancesDBItem 
* 
* \brief SchedulerInstancesDBItem - 
* 
* \details
*
* \section SchedulerInstancesDBItem_intro_sec Introduction
*
* \section SchedulerInstancesDBItem.java_samples Some Samples
*
* \code
*   .... code goes here ...
* \endcode
*
* <p style="text-align:center">
* <br />---------------------------------------------------------------------------
* <br /> APL/Software GmbH - Berlin
* <br />##### generated by ClaviusXPress (http://www.sos-berlin.com) #########
* <br />---------------------------------------------------------------------------
* </p>
* \author Uwe Risse
* \version 23.09.2011
* \see reference
*
* Created on 23.09.2011 15:08:05
 */

import java.text.SimpleDateFormat;
import java.util.Date;
import javax.persistence.*;
import com.sos.hibernate.classes.DbItem;

@Entity
@Table(name="SCHEDULER_INSTANCES")
public class SchedulerInstancesDBItem extends DbItem {
	
	private Long id;
	private String schedulerId;
	 
	 private String hostName;
	 private Integer tcpPort;
	 private Integer udpPort;
	 private Date startTime;
	 private Date stopTime;
	 private String dbName;
	 private String dbHistoryTableName;
	 private String dbOrderHistoryTableName;
	 private String dbOrdersTableName;
	 private String dbTasksTableName;
	 private String dbVariablesTableName;
	 private String workingDirectory;
	 private String liveDirectory;
	 private String logDir;
	 private String includePath;
	 private String iniPath;
	 private Boolean isService=false;
	 private Boolean isRunning=false;
	 private Boolean isPaused=false;
	 private Boolean isCluster=false;
	 private Boolean isAgent=false;
	 private String param;
	 	 
  	 private String dateFormat="yyyy-MM-dd hh:mm";

 	public SchedulerInstancesDBItem(String dateFormat_) {
		this.dateFormat = dateFormat_;
	}
	
 	public SchedulerInstancesDBItem() {
 	
 	}
      
    @Id
    @GeneratedValue(strategy=GenerationType.AUTO)
    @Column(name="ID")
    public Long getId() {
		return id;
	}

    @Column(name="ID")
	public void setId(Long id) {
		this.id = id;
	}

    @Column(name="SCHEDULER_ID",nullable=false)
	public void setSchedulerId(String schedulerId) {
		this.schedulerId = schedulerId;
	}
    
     
    @Column(name="SCHEDULER_ID",nullable=false)
	public String getSchedulerId() {
		return schedulerId;
	}
    
    @Column(name = "HOSTNAME", nullable = true)
	public void setHostname(String hostname) {
		this.hostName = hostname;
	}

	@Column(name = "HOSTNAME", nullable = true)
	public String getHostname() {
		return hostName;
	}
	
    @Column(name = "TCP_PORT", nullable = true)
	public void setTcpPort(int tcpPort) {
		this.tcpPort = tcpPort;
	}

	@Column(name = "TCP_PORT", nullable = true)
	public int getTcpPort() {
		return tcpPort;
	}
    @Column(name = "UDP_PORT", nullable = true)
	public void setUdpPort(Integer udpPort) {
		this.udpPort = udpPort;
	}

	@Column(name = "UDP_PORT", nullable = true)
	public Integer getUdpPort() {
		return udpPort;
	}
	
	  @Temporal (TemporalType.TIMESTAMP)
	    @Column(name="START_TIME",nullable=true)
		public void setStartTime(Date startTime) {
			this.startTime = startTime;
		}
	    
	    @Temporal (TemporalType.TIMESTAMP)
	    @Column(name="START_TIME",nullable=true)
		public Date getStartTime() {
			return startTime;
		}    
	    
	    @Transient 
	    public String getSchedulePlannedIso(){
	 		if (this.getStartTime() == null) {
	 			return "";
	 		}else{
	 		    SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
	 		    String startTimeIso = formatter.format(this.getStartTime());
	 		    return startTimeIso;
	 		}
	 	}
	    
	    @Transient 
	    
	    public String getStartTimeFormated(){
	        return getDateFormatted(this.getStartTime());
	 	}
	    
	    @Temporal (TemporalType.TIMESTAMP)
	    @Column(name="START_TIME",nullable=true)
		public void setStopTime(Date stopTime) {
			this.stopTime = stopTime;
		}
	    
	    @Temporal (TemporalType.TIMESTAMP)
	    @Column(name="STOP_TIME",nullable=true)
		public Date getStopTime() {
			return stopTime;
		}    
	    
	    @Transient 
	    public String getStopTimeIso(){
	 		if (this.getStopTime() == null) {
	 			return "";
	 		}else{
	 		    SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
	 		    String stopTimeIso = formatter.format(this.getStopTime());
	 		    return stopTimeIso;
	 		}
	 	}
	    
	    @Transient 
	    public String getStopTimeFormated(){
	        return getDateFormatted(this.getStopTime());
	 	}
	    
	    @Column(name = "DB_NAME", nullable = true)
		public void setDbName(String dbName) {
			this.dbName = dbName;
		}

	    @Column(name = "DB_NAME", nullable = true)
		public String getDbName() {
			return dbName;
		}



	    @Column(name = "DB_HISTORY_TABLE_NAME", nullable = true)
		public void setDbHistoryTableName(String dbHistoryTableName ) {
			this.dbHistoryTableName = dbHistoryTableName;
		}

	    @Column(name = "DB_HISTORY_TABLE_NAME", nullable = true)
		public String getDbHistoryTableName() {
			return dbHistoryTableName;
		}
	    
	    @Column(name = "DB_ORDER_HISTORY_TABLE_NAME", nullable = true)
		public void setDbOrderHistoryTableName(String dbOrderHistoryTableName ) {
			this.dbOrderHistoryTableName = dbOrderHistoryTableName;
		}

	    @Column(name = "DB_ORDER_HISTORY_TABLE_NAME", nullable = true)
		public String getDbOrderHistoryTableName() {
			return dbOrderHistoryTableName;
		}

	    @Column(name = "DB_ORDERS_TABLE_NAME", nullable = true)
		public void setDbOrdersTableName(String dbOrdersTableName ) {
			this.dbOrdersTableName = dbOrdersTableName;
		}

	    @Column(name = "DB_ORDERS_TABLE_NAME", nullable = true)
		public String getDbOrdersTableName() {
			return dbOrdersTableName;
		}

	    @Column(name = "DB_TASKS_TABLE_NAME", nullable = true)
		public void setDbTasksTableName(String dbTasksTableName ) {
			this.dbTasksTableName = dbTasksTableName;
		}

	    @Column(name = "DB_TASKS_TABLE_NAME", nullable = true)
		public String getDbTasksTableName() {
			return dbTasksTableName;
		}

	    @Column(name = "DB_VARIABLES_TABLE_NAME", nullable = true)
		public void setDbVariablesTableName(String dbVariablesTableName ) {
			this.dbVariablesTableName = dbVariablesTableName;
		}

	    @Column(name = "DB_VARIABLES_TABLE_NAME", nullable = true)
		public String getDbVariablesTableName() {
			return dbVariablesTableName;
		}
	    
	    @Column(name = "WORKING_DIRECTORY", nullable = true)
		public void setWorkingDirectory(String workingDirectory ) {
			this.workingDirectory = workingDirectory;
		}

	    @Column(name = "WORKING_DIRECTORY", nullable = true)
		public String getWorkingDirectory() {
			return workingDirectory;
		}

	    
	    @Column(name = "LIVE_DIRECTORY", nullable = true)
		public void setLiveDirectory(String liveDirectory ) {
			this.liveDirectory = liveDirectory;
		}

	    @Column(name = "LIVE_DIRECTORY", nullable = true)
		public String getLiveDirectory() {
			return liveDirectory;
		}
	    
	    @Column(name = "LOG_DIR", nullable = true)
		public void setLogDir(String logDir ) {
			this.logDir = logDir;
		}

	    @Column(name = "LOG_DIR", nullable = true)
		public String getLogDir() {
			return logDir;
		}
	    
	    @Column(name = "INCLUDE_PATH", nullable = true)
		public void setIncludePath(String includePath ) {
			this.includePath = includePath;
		}

	    @Column(name = "INCLUDE_PATH", nullable = true)
		public String getIncludePath() {
			return includePath;
		}
	    
	    @Column(name = "INI_PATH", nullable = true)
		public void setIniPath(String iniPath ) {
			this.iniPath = iniPath;
		}

	    @Column(name = "INI_PATH", nullable = true)
		public String getIniPath() {
			return iniPath;
		}

	    
	    @Column(name = "IS_SERVICE", nullable = true)
		public void setIsService(Boolean isService ) {
			this.isService = isService;
		}

	    @Column(name = "IS_SERVICE", nullable = true)
		public Boolean getIsService() {
			return isService;
		}
	    
	    
	    @Column(name = "IS_RUNNING", nullable = true)
		public void setIsRunning(Boolean isRunning ) {
			this.isRunning = isRunning;
		}

	    @Column(name = "IS_RUNNING", nullable = true)
		public Boolean getIsRunning() {
			return isRunning;
		}	    
	    
	    @Column(name = "IS_PAUSED", nullable = true)
		public void setIsPaused(Boolean isPaused ) {
			this.isPaused = isPaused;
		}

	    @Column(name = "IS_PAUSED", nullable = true)
		public Boolean getIsPaused() {
			return isPaused;
		}	    
	    
	    @Column(name = "IS_CLUSTER", nullable = true)
		public void setIsCluster(boolean isCluster ) {
			this.isCluster = isCluster;
		}

	    @Column(name = "IS_CLUSTER", nullable = true)
		public Boolean getIsCluster() {
			return isCluster;
		}	    

	    @Column(name = "IS_AGENT", nullable = true)
		public void setIsAgent(Boolean isAgent ) {
			this.isAgent = isAgent;
		}

	    @Column(name = "IS_AGENT", nullable = true)
		public Boolean getIsAgent() {
			return isAgent;
		}	    
	    
	    @Column(name = "PARAM", nullable = true)
		public void setParam(String param ) {
			this.param = param;
		}

	    @Column(name = "PARAM", nullable = true)
		public String getParam() {
			return param;
		}
 
	
}
