/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
package com.sos.scheduler.history.db;

//com.sos.scheduler.history
 

import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Date;
import javax.persistence.*;

import sos.spooler.Job_chain;

import com.sos.hibernate.classes.DbItem;
import com.sos.scheduler.history.classes.SOSStreamUnzip;
 


/**
* \class SchedulerOrderHistoryDBItem 
* 
* \brief SchedulerOrderHistoryDBItem - 
* 
* \details
*
* \section SchedulerOrderHistoryDBItem.java_intro_sec Introduction
*
* \section SchedulerOrderHistoryDBItem.java_samples Some Samples
*
* \code
*   .... code goes here ...
* \endcode
*
* <p style="text-align:center">
* <br />---------------------------------------------------------------------------
* <br /> APL/Software GmbH - Berlin
* <br />##### generated by ClaviusXPress (http://www.sos-berlin.com) #########
* <br />---------------------------------------------------------------------------
* </p>
* \author Uwe Risse
* \version 13.05.2011
* \see reference
*
* Created on 13.05.2011 16:42:58
 */

@Entity
@Table(name="SCHEDULER_ORDER_HISTORY")
public class SchedulerOrderHistoryDBItem extends DbItem {
	
	 private Long historyId;
	 private String spoolerId;
	 private String orderId;
	 private String jobChain;
	 private Date startTime;
     private Date endTime;
     private String title;
     private String state;
     private String stateText;
     private byte[] log;
	 
     private boolean assignToDaysScheduler;

	public SchedulerOrderHistoryDBItem() {
	 
	}
     
    @Id
    @GeneratedValue(strategy=GenerationType.AUTO)
    @Column(name="`HISTORY_ID`",nullable=false) 
    public Long getHistoryId() {
		return historyId;
	}

    @Column(name="`HISTORY_ID`",nullable=false) 
	public void setHistoryId(Long id) {
		this.historyId = id;
	}

   @Column(name="`SPOOLER_ID`",nullable=false)
	public String getSpoolerId() {
		return spoolerId;
	}

   @Column(name="`SPOOLER_ID`",nullable=false)
	public void setSpoolerId(String spoolerId) {
		this.spoolerId = spoolerId;
	}

   @Column(name="`ORDER_ID`",nullable=false)
	public String getOrderId() {
		return orderId;
	}

   @Column(name="`ORDER_ID`",nullable=false)
	public void setOrderId(String orderId) {
		this.orderId = orderId;
	}

   @Column(name="`JOB_CHAIN`",nullable=false)
   public String getJobChain() {
		return jobChain;
	}

   @Column(name="`JOB_CHAIN`",nullable=false)
	public void setJobChain(String jobChain) {
		this.jobChain = jobChain;
	}

   @Column(name="`START_TIME`", nullable=false)
   @Temporal(TemporalType.TIMESTAMP)
   public Date getStartTime() {
		return startTime;
	}
  
   @Column(name="`START_TIME`", nullable=false)
   @Temporal(TemporalType.TIMESTAMP)
	public void setStartTime(Date startTime) {
		this.startTime = startTime;
	}

   @Column(name="`END_TIME`", nullable=true)
   @Temporal(TemporalType.TIMESTAMP)
	public Date getEndTime() {
		return endTime;
	}


	
   @Column(name="`END_TIME`", nullable=true)
   @Temporal(TemporalType.TIMESTAMP)
	public void setEndTime(Date endTime) {
		this.endTime = endTime;
	}

   @Column(name="`TITLE`", nullable=true)
	public String getCause() {
 		return title;
	}

   @Column(name="`TITLE`", nullable=true)
	public void setCause(String title) {
		this.title = title;
	}

   @Column(name="`STATE`", nullable=true)
	public String getState() {
		return state;
	}

  @Column(name="`STATE`", nullable=true)
	public void setState(String state) {
		this.state = state;
	}

  @Lob
  @Column(name="`LOG`", nullable=true)
	public byte[] getLog() {
		return log;
	}
 
  @Transient 
  public String getStartTimeIso() {
		if (this.getStartTime() == null) {
			return "";
		}else{
		    SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd HH:mm");
		    String startTimeIso = formatter.format(this.getStartTime());
		    return startTimeIso;
		}
	}
 
  @Transient 
  public String getEndTimeIso() {
		if (this.getEndTime() == null) {
			return "";
		}else{
		    SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd HH:mm");
		    String endTimeIso = formatter.format(this.getEndTime());
		    return endTimeIso;
		}
	}

  
  
  @Transient
  public String getLogAsString() throws IOException {
	   if (log == null) {
		   return null;
	   }else {
		   SOSStreamUnzip SOSUnzip = new SOSStreamUnzip(log);
		   return SOSUnzip.unzip2String();
	   }
   }   



  
  @Column(name="`LOG`", nullable=true)
	public void setLog(byte[] log) {
		this.log = log;
	}

   

   @Column(name="`STATE_TEXT`",nullable=true)
	public String getStateText() {
	    return stateText;
	}

   @Column(name="`STATE_TEXT`",nullable=true)
	public void setStateText(String stateText) {
		this.stateText = stateText;
	}

   //If the name would be getStartTimeIso, a setter for startTimeIso must be implemented
   public String readStartTimeIso() {
		if (this.getStartTime() == null) {
			return "";
		}else{
		    SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd HH:mm");
		    String startTimeIso = formatter.format(this.getStartTime());
		    return startTimeIso;
		}
	}
  
   //If the name would be getEndTimeIso, a setter for endTimeIso must be implemented
   public String readEndTimeIso() {
		if (this.getEndTime() == null) {
			return "";
		}else{
		    SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd HH:mm");
		    String endTimeIso = formatter.format(this.getEndTime());
		    return endTimeIso;
		}
	}
	 @Transient 
	    public String getStartTimeFormated(){
	        return getDateFormatted(this.getStartTime());
	 	}
	 @Transient 
	    public String getEndTimeFormated(){
	        return getDateFormatted(this.getEndTime());
	 	}

   
   @Transient
   public boolean isAssignToDaysScheduler() {
		return assignToDaysScheduler;
	}


	@Transient
	public void setAssignToDaysScheduler(boolean assignToDaysScheduler) {
		this.assignToDaysScheduler = assignToDaysScheduler;
	}
	
	@Transient
	public Long getLogId() {
		return this.getHistoryId();
	}
	
	@Transient
	public String getIdentifier(){
 		return this.getJobChain() + "/" + this.getOrderId();
	}
 	
	@Transient
	public boolean isStandalone() {
 		return false;
 	}

	@Transient
	public String getSchedulerId() {
 		return this.getSpoolerId();
 	}

	@Transient
	public String getTitle() {
		return jobChain + "/" + orderId  ;
	}
	
	@Transient
	public String getExecResult() {
		return this.getState();
	}
	
	@Transient
	public boolean haveError() {
		return (this.getState().toLowerCase().contains("error") || 
				this.getState().toLowerCase().contains("fehler") ||
				this.getState().toLowerCase().contains("fault"));
	}
	
	@Transient
	public boolean equals(Object h) {
		return (((SchedulerOrderHistoryDBItem) h).getJobChain().equals(this.getJobChain()) && ((SchedulerOrderHistoryDBItem) h).getOrderId().equals(this.getOrderId()));
	}	
 
}
