/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
package sos.scheduler.editor.app;

import org.jdom.Element;

public class TreeData {
    private int     _type;

    private Element _element;

    private String  _helpKey;

    private String  _child;


    public TreeData() {

    }


    public TreeData(int type, Element element, String helpKey, String child) {
        _type = type;
        _element = element;
        _helpKey = helpKey;
        _child = child;
    }


    public TreeData(int type, Element element, String helpKey) {
        this(type, element, helpKey, null);
    }


    // public TreeData(int type, Element element) {
    // this(type, element, null);
    // }

    public int getType() {
        return _type;
    }


    public void setType(int type) {
        _type = type;
    }

 
    public Element getElement() {
        return _element;
    }


    public void setElement(Element element) {
        _element = element;
    }


    public String getHelpKey() {
        return _helpKey;
    }


    public void setHelpKey(String helpKey) {
        _helpKey = helpKey;
    }


    public String getChild() {
        return _child;
    }


    public void setChild(String child) {
        _child = child;
    }


    public boolean equals(int type) {
        return _type == type;
    }
}
