/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// $Id

package sos.spooler;

/**
 * Applikationsklasse zum Start im Java-Debugger.
 *
 * Nur für Windows.
 * Die Klasse erwartet den Scheduler als nachladbares Modul in der Datei <code>scheduler.dll</code>,
 * deren Verzeichnis in <code>java.library.path</code> 
 * oder in der Umgebungsvariable <code>PATH</code> aufgeführt sein muss.
 *
 * @author Joacim Zschimmer, Zschimmer GmbH
 * @version $Revision: 3946 $
 */

public class Spooler_program
{


    /** Start des Schedulers mit Kommandozeile als Array.
      * Der erste Parameter bezeichnet den Pfad der zu der <code>scheduler.dll</code> passenden <code>scheduler.exe</code>.
     */
    
    public                  Spooler_program         ( String parameters[] )             { construct_argv( parameters ); }

    private native void     construct_argv          ( String[] parameters );


    /**
     * Die Parameter werden dem Scheduler übergeben wie beim Aufruf der normalen Variante über die Kommandozeile.
     */
     
    public static void main( String[] parameters )
    {
        String[] p = new String[ parameters.length + 1 ];

        p[0] = "scheduler.exe";
        for( int i = 0; i < parameters.length; i++ )  p[i+1] = parameters[i];

        new Spooler_program( p );
    }

    static
    {
        System.loadLibrary( "scheduler" );
    }
}
