/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// $Id: utf8.h 11394 2005-04-03 08:30:29Z jz $

#ifndef __ZSCHIMMER_UTF8
#define __ZSCHIMMER_UTF8

namespace zschimmer {

//-------------------------------------------------------------------------------------------------

int                             utf8_byte_count_from_iso_8859_1( const char* iso_8859_1, int length );
int                             utf8_byte_count_from_iso_8859_1( const char* iso_8859_1 );
inline int                      utf8_byte_count_from_iso_8859_1( const string& iso_8859_1 )             { return utf8_byte_count_from_iso_8859_1( iso_8859_1.data(), iso_8859_1.length() ); }

int                             write_iso_8859_1_as_utf8    ( const char* iso_8859_1, int length, char* utf8_buffer, int buffer_size );
inline int                      write_iso_8859_1_as_utf8    ( const string& iso_8859_1, char* utf8_buffer, int buffer_size ) { return write_iso_8859_1_as_utf8( iso_8859_1.data(), iso_8859_1.length(), utf8_buffer, buffer_size ); }

int                             write_utf8_as_unicode       ( const char* utf8, int utf8_length, OLECHAR* unicode, int unicode_size );
int                             write_unicode_as_utf8       ( const OLECHAR* unicode, int length, char* utf8_buffer, int buffer_size );

string                          iso_8859_1_from_utf8        ( const char* utf8, int utf8_length );
inline string                   iso_8859_1_from_utf8        ( const char* utf8 )                        { return iso_8859_1_from_utf8( utf8, strlen( utf8 ) ); }
inline string                   iso_8859_1_from_utf8        ( const string& utf8 )                      { return iso_8859_1_from_utf8( utf8.data(), utf8.length() ); }


string                          utf8_from_iso_8859_1        ( const char* iso_8859_1, int length );
inline string                   utf8_from_iso_8859_1        ( const char* iso_8859_1 )                  { return utf8_from_iso_8859_1( iso_8859_1, strlen( iso_8859_1  ) ); }
inline string                   utf8_from_iso_8859_1        ( const string& iso_8859_1 )                { return utf8_from_iso_8859_1( iso_8859_1.data(), iso_8859_1.length() ); }

int                             utf8_length                 ( const char* utf8, int byte_count );
int                             utf8_length                 ( const char* utf8 );

//-------------------------------------------------------------------------------------------------

} //namespace zschimmer

#endif
